package com.zh.test_zabbix.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class GlobalCorsConfig {

    @Bean
    public WebMvcConfigurer corsConfigurer() {
        return new WebMvcConfigurer() {

            @Override // 重写父类提供的跨域请求处理的接口
            public void addCorsMappings(CorsRegistry registry) {
                // 添加映射路径
                registry.addMapping("/**")
                        // 放行哪些原始域
                        // .allowedOrigins("*")
                        // .allowedOrigins("localhost:8080")
                        .allowedOriginPatterns("*")
                        // 是否发送Cookie信息
                        .allowCredentials(true)
                        // 放行哪些原始域(请求方式)
                        .allowedMethods("GET", "POST", "PUT", "DELETE")
                        // 放行哪些原始域(头部信息)
                        .allowedHeaders("*")
                        // 暴露哪些头部信息（因为跨域访问默认不能获取全部头部信息）
                        .exposedHeaders("Header1", "Header2");
            }
        };
    }

    /*
     * @Bean public FilterRegistrationBean corsFilter() {
     * UrlBasedCorsConfigurationSource source = new
     * UrlBasedCorsConfigurationSource(); CorsConfiguration config = new
     * CorsConfiguration(); config.setAllowCredentials(true);
     * config.addAllowedOrigin("*"); config.addAllowedHeader("*");
     * config.addAllowedMethod("*"); source.registerCorsConfiguration("/**",
     * config); FilterRegistrationBean bean = new FilterRegistrationBean(new
     * CorsFilter(source)); bean.setOrder(0); return bean; }
     */
}
