package com.zh.test_zabbix.config;

/**
 * host所有类型枚举
 */
public enum HostCategoryEnum {

    AIX(-1,"AIX",10076,1,""),
    LINUX(1,"Linux",10001,1,""),
    WINDOWS(-1,"Windows",10081,1,""),
    LINUX_SNMP(-1,"Linux SNMP",10248,2,""),
    WINDOWS_SNMP(-1,"Windows SNMP",10249,2,""),

    MYSQL(5,"MySQL",10320,1,""),
    POSTGRESQL(6,"PostgreSQL",10329,1,""),
    ORACLE(7,"Oracle",10335,1,""),
    MICROSOFT_SQL_SERVER(8,"Microsoft SQL Server",10360,1,""),
    MONGODB(9,"MongoDB",10386,1,""),
    REDIS(10,"Redis",10310,1,""),


            ;

    private final int id;
    private final String name;
    private final int templateid;
    private final int interfaceType;
    private final String description;


    HostCategoryEnum(int id, String name, int templateid,int interfaceType,String description) {
        this.id = id;
        this.name = name;
        this.templateid = templateid;
        this.interfaceType = interfaceType;
        this.description = description;
    }

    public Long id() {
        return Long.valueOf(id);
    }
    public String title() {
        return name;
    }
    public Long templateid() {
        return Long.valueOf(templateid);
    }
    public int interfaceType() {
        return interfaceType;
    }


    public static HostCategoryEnum valueOf(Long id) {
        if(null == id){
            return null;
        }
        int i ;
        try {
             i = Math.toIntExact(id);
        } catch (ArithmeticException e) {
            return  null;
        }
        for (HostCategoryEnum cate : values()) {
            if (cate.id() == i) {
                return cate;
            }
        }
//        throw new IllegalArgumentException("No matching constant for [" + id + "]");
        return  null;
    }


}