package com.zh.test_zabbix.config;

public enum ItemEnum {

    CPU_PRESENT_STATUS(101, "inspur.server.processor.present.status.", "cpu_present_status"),
    CPU_MODEL_INFO(102, "inspur.server.processor.model.info.", "CPU_model_info"),
    CPU_USED_CORE(103, "inspur.server.processor.used.core.", "CPU_used_core"),
    MEMORY_PRESENT_STATUS(201, "inspur.server.memory.present.status.", "memory_present_status"),
    MEMORY_SN(202, "inspur.server.memory.sn.", "memory_sn"),
    MEMORY_CAPACITY(203, "inspur.server.memory.capacity.", "memory_capacity"),
    DISK_STATUS(301, "inspur.server.disk.info.status.", "disk_status"),
    DISK_SN(302, "inspur.server.disk.model.", "disk_model"),
    DISK_TYPE(303, "inspur.server.disk.type.", "disk_type"),
    FAN_STATUS(401, "inspur.server.fan.status.", "fan_status"),
    FAN_SPEED(402, "inspur.server.fan.speed.value.", "fan_speed"),
    MICROCONTROLLER_PRESENT_STATUS(501, "inspur.server.microcontroller.status.", "microcontroller_present_status"),
    RAID_STATUS(601, "inspur.server.raid.status.", "raid_status"),

    TEMPERATURE_STATUS(801, "inspur.server.temperature.status.", "temperature_status"),
    TEMPERATURE_Value(802, "inspur.server.temperature.value.", "temperature_value"),
    POWER_SUPPLY_STATUS(901, "inspur.server.power.supply.status.", "power_supply_status"),

    // linux相关监控项
    LINUX_BASE_SW_OS(1001,"system.sw.os","base_os"),
    LINUX_BASE_BOOT_TIME(1002,"system.boottime","base_boottime"),
    LINUX_BASE_CPU_NUM(1003,"system.cpu.num","base_cpu_num"),

    LINUX_CPU_LOAD_AVERAGE(1101,"system.cpu.load","cpu_load_average"),
    LINUX_CPU_UTILIZATION(1102,"system.cpu.util","cpu_utilization"),

    LINUX_MEMORY_SIZE(1201,"vm.memory.size","memory_size"),
    LINUX_MEMORY_UTILIZATION(1202,"vm.memory.utilization","memory_utilization"),

    LINUX_SWAP_SIZE(1301,"system.swap.size","swap_size"),

    LINUX_DISK_UTILIZATION(1401,"vfs.dev.util","disk_utilization"),
    LINUX_DISK_AVERAGE_QUEUE_SIZE(1401,"vfs.dev.queue_size","disk_average_queue_size"),
    LINUX_DISK_READ_RATE(1402,"vfs.dev.read.rate","disk_read_rate"),
    LINUX_DISK_READ_TIME_RATE(1403,"vfs.dev.read.time.rate","disk_read_time_rate"),
    LINUX_DISK_READ_AWAIT(1404,"vfs.dev.read.await","disk_read_await"),
    LINUX_DISK_WRITE_RATE(1405,"vfs.dev.write.rate","disk_write_rate"),
    LINUX_DISK_WRITE_TIME_RATE(1406,"vfs.dev.write.time.rate","disk_write_time_rate"),
    LINUX_DISK_WRITE_AWAIT(1407,"vfs.dev.write.await","disk_write_await"),

    LINUX_INTERFACE_BITS_RECEIVED(1501,"net.if.in","net_if_in"),
    LINUX_INTERFACE_BITS_SENT(1502,"net.if.out","net_if_out"),
    LINUX_INTERFACE_INFO(1503,"vfs.file.contents","net_if_info"),

    // windows相关监控项

    // oracle相关监控项
    ORACLE_VERSION(2101,"oracle.version","oracle_version"),
    ORACLE_FRA_USABLE_PCT(2102,"oracle.fra_usable_pct","fra_usable_space"),
    ORACLE_TBS_STATUS(2103,"oracle.tbs_status","tbs_status"),
    ;

    private final int id;
    private final String key_;
    private final String serial;
    private final String word;

    ItemEnum(int id, String key_, String word) {
        this.id = id;
        this.key_ = key_;
        this.serial = null;
        this.word = word;
    }
    ItemEnum(int id, String key_,String serial, String word) {
        this.id = id;
        this.key_ = key_;
        this.serial = serial;
        this.word = word;
    }

    public int id() {
        return id;
    }

    public String key_() {
        return key_;
    }

    public String serial() {
        return serial;
    }

    public String word() {
        return word;
    }

    public static ItemEnum valueOf(int id) {
        for (ItemEnum i : values()) {
            if (i.id() == id) {
                return i;
            }
        }
//        throw new IllegalArgumentException("No matching constant for [" + id + "]");
        return null;
    }

    public static ItemEnum searchKeyId(String key_) {
        for (ItemEnum i : values()) {
            if (i.key_().equals(key_)) {
                return i;
            }
        }
        return null;
    }
}
