package com.zh.test_zabbix.controller;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zh.test_zabbix.config.Config;
import com.zh.test_zabbix.utils.ZabbixApi;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("global")
public class GlobalData_ {


    @RequestMapping("/graph")
    public JSONObject graph() {

        // 预设的图表id（graphid）
        String[] a = {"3142", "3143"};

        // 根据graphid获取监控项
        JSONObject argGraphitem = new JSONObject();
        argGraphitem.put("graphids", a);
        JSONObject resGraphitem = ZabbixApi.post("graphitem.get", Config.AUTH, argGraphitem);
        ArrayList<String> itemids = new ArrayList<>();
        HashMap<String, ArrayList<String>> graphitemids = new HashMap();
        try {
            JSONArray resGraphitemResult = resGraphitem.getJSONArray("result");
            for (Object i : resGraphitemResult) {
                JSONObject obj = (JSONObject) i;
                itemids.add((obj.getString("itemid")));
                String p = obj.getString("graphid");
                if (null == graphitemids.get(p)) {
                    graphitemids.put(p, new ArrayList<String>());
                }
                graphitemids.get(p).add(obj.getString("itemid"));
            }
        } catch (Exception e) {
            System.out.println("ERROR:方法graphitem.get结果异常！");
//           log
            e.printStackTrace();
        }

        // 根据监控项id（itemid）获取监控项信息
        JSONObject argItem = new JSONObject();
        argItem.put("itemids", itemids);
        JSONObject resItem = ZabbixApi.post("item.get", Config.AUTH, argItem);
        ArrayList<JSONObject> itemsInfo = new ArrayList<>();
        try {
            JSONArray resItemResult = resItem.getJSONArray("result");
            for (Object i : resItemResult) {
                itemsInfo.add((JSONObject) i);
            }
        } catch (Exception e) {
            System.out.println("ERROR:方法item.get结果异常！");
//           log
            e.printStackTrace();
        }

        // 根据监控项id（itemid）获取监控项历史数据

        HashMap<String, JSONObject> itemHistories = new HashMap<>();
        for (JSONObject i : itemsInfo) {
            JSONObject argHistory = new JSONObject();
            argHistory.put("itemids", i.getString("itemid"));
            argHistory.put("history", i.getString("value_type"));
            argHistory.put("limit", Config.LIMIT);
            argHistory.put("sortfield", "clock");
            argHistory.put("sortorder", "DESC");

            JSONArray resHistory = (ZabbixApi.post("history.get", Config.AUTH, argHistory)).getJSONArray("result");
            ArrayList<String> value = new ArrayList<>();
            ArrayList<String> clock = new ArrayList<>();
            for (Object o : resHistory) {
                value.add(((JSONObject) o).getString("value"));
                clock.add(((JSONObject) o).getString("clock"));
            }

            JSONObject data = new JSONObject();
            data.put("itemid", i.getString("itemid"));
            data.put("value_type", i.getString("value_type"));
            data.put("value_type_text", Config.item.value_type(i.getString("value_type")));
            data.put("value", value);
            data.put("clock", clock);
            itemHistories.put(i.getString("itemid"), data);
        }

        JSONObject result = new JSONObject();

        JSONArray frames = new JSONArray();
        for (Map.Entry<String, ArrayList<String>> entry : graphitemids.entrySet()) {
            String key = entry.getKey();
            ArrayList<String> value = entry.getValue();

            JSONObject frameGraph = new JSONObject();
            frameGraph.put("graphid", key);
            frameGraph.put("name", key);
            frameGraph.put("graphtype", key);

            JSONArray framesItem = new JSONArray();
            for (String v : value) {
                for (Map.Entry<String, JSONObject> e : itemHistories.entrySet()) {
                    if (v.equals(e.getKey())) {
                        framesItem.add(e.getValue());
                    }
                }
            }
            frameGraph.put("itemHistries", framesItem);
            frames.add(frameGraph);
        }

        result.put("frames", frames);
        return result;
    }
}
