package com.zh.test_zabbix.controller;


import com.zh.test_zabbix.service.IHostsService;
import com.zh.test_zabbix.serviceImpl.HostsServiceImpl;
import com.zh.test_zabbix.utils.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@RestController
@RequestMapping("/host")
public class Hosts {

    @Autowired
    private IHostsService hostService;

    @RequestMapping("/get")
    public Result get(@RequestBody HostsServiceImpl.ArgGet args) {
        return hostService.get(args);
    }

    @RequestMapping("/detail")
    public Result detail(@RequestBody HostsServiceImpl.ArgDetail args) {
        return hostService.detail(args);
    }

    @RequestMapping("/detail/count")
    public Result detail_count(@RequestBody HostsServiceImpl.ArgDetail args) {
        return hostService.detail_count(args);
    }

    @RequestMapping("/create")
    public Result create(@Validated @RequestBody HostsServiceImpl.ArgCreate args) {
        return hostService.create(args);
    }

    @RequestMapping("/delete")
    public Result delete(@RequestBody HostsServiceImpl.ArgDelete args) {
        return hostService.delete(args);
    }

    @RequestMapping("/update")
    public Result update(@RequestBody HostsServiceImpl.ArgUpdate args) {
        return hostService.update(args);
    }

    @RequestMapping("/collection/list")
    public Result collectionList() {
        return hostService.collectionList();
    }

    @RequestMapping("/count")
    public Result count(@RequestBody HostsServiceImpl.ArgCount args) {
        return hostService.count(args);
    }

    @RequestMapping("/valuemap/list")
    public Result get(@RequestBody HostsServiceImpl.ArgValuemapGet args) {
        return hostService.valuemapList(args);
    }

    @RequestMapping("/valuemap/create")
    public Result valuemapCreate(@Validated @RequestBody HostsServiceImpl.ArgValuemapCreate args) {
        return hostService.valuemapCreate(args);
    }

    @RequestMapping("/fastAdd")
    public Result fastAdd(@Validated @RequestBody HostsServiceImpl.ArgFastAdd args) {
        return hostService.fastAdd(args);
    }

    @RequestMapping("/install")
    public Result install(@RequestBody HostsServiceImpl.ArgAgentInstall args) {
        return hostService.agentInstall(args);
    }
}
