package com.zh.test_zabbix.controller;


import com.zh.test_zabbix.service.IItemsService;
import com.zh.test_zabbix.serviceImpl.ItemsServiceImpl;
import com.zh.test_zabbix.utils.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@RestController
@RequestMapping("/item")
public class Item {

    @Autowired
    private IItemsService itemService;

    @RequestMapping("/get")
    public Result get(@RequestBody ItemsServiceImpl.ArgGet args) {
        return itemService.get(args);
    }

    @RequestMapping("/data")
    public Result data(@RequestBody ItemsServiceImpl.ArgData args) {
        return itemService.data(args);
    }

    @RequestMapping("/detail")
    public Result detail(@Validated @RequestBody ItemsServiceImpl.ArgDetail args) {
        return itemService.detail(args);
    }

    @RequestMapping("/create")
    public Result create(@Validated @RequestBody ItemsServiceImpl.ArgCreate args) {
        return itemService.create(args);
    }

    @RequestMapping("/delete")
    public Result delete(@RequestBody ItemsServiceImpl.ArgDelete args) {
        return itemService.delete(args);
    }

    @RequestMapping("/update")
    public Result update(@Validated @RequestBody ItemsServiceImpl.ArgUpdate args) {
        return itemService.update(args);
    }

    @RequestMapping("/status")
    public Result switchStatus(@Validated @RequestBody ItemsServiceImpl.ArgSwitchStatus args) {
        return itemService.switchStatus(args);
    }

    @RequestMapping("/discovery/get")
    public Result getItemDiscovery(@RequestBody ItemsServiceImpl.ArgGetItemDiscovery args) {
        return itemService.getItemDiscovery(args);
    }

    @RequestMapping("/discovery/detail")
    public Result itemDiscoveryDetail(@Validated @RequestBody ItemsServiceImpl.ArgItemDiscoveryDetail args) {
        return itemService.itemDiscoveryDetail(args);
    }

    @RequestMapping("/discovery/create")
    public Result itemDiscoveryCreate(@Validated @RequestBody ItemsServiceImpl.ArgItemDiscoveryCreate args) {
        return itemService.itemDiscoveryCreate(args);
    }

    @RequestMapping("/discovery/delete")
    public Result itemDiscoveryDelete(@RequestBody ItemsServiceImpl.ArgItemDiscoveriesDelete args) {
        return itemService.itemDiscoveriesDelete(args);
    }

    @RequestMapping("/discovery/update")
    public Result itemDiscoveryUpdate(@Validated @RequestBody ItemsServiceImpl.ArgItemDiscoveryUpdate args) {
        return itemService.itemDiscoveryUpdate(args);
    }

    @RequestMapping("/discovery/status")
    public Result itemDiscoverySwitchStatus(@Validated @RequestBody ItemsServiceImpl.ArgItemDiscoverySwitchStatus args) {
        return itemService.itemDiscoverySwitchStatus(args);
    }

    @RequestMapping("/itemprototype/get")
    public Result getItemprototype(@RequestBody ItemsServiceImpl.ArgGetItemprototype args) {
        return itemService.getItemprototype(args);
    }

    @RequestMapping("/itemprototype/detail")
    public Result itemprototypeDetail(@Validated @RequestBody ItemsServiceImpl.ArgItemprototypeDetail args) {
        return itemService.itemprototypeDetail(args);
    }

    @RequestMapping("/itemprototype/create")
    public Result itemprototypeCreate(@Validated @RequestBody ItemsServiceImpl.ArgItemprototypeCreate args) {
        return itemService.itemprototypeCreate(args);
    }

    @RequestMapping("/itemprototype/delete")
    public Result itemprototypeDelete(@RequestBody ItemsServiceImpl.ArgItemprototypeDelete args) {
        return itemService.itemprototypeDelete(args);
    }

    @RequestMapping("/itemprototype/update")
    public Result itemprototypeUpdate(@Validated @RequestBody ItemsServiceImpl.ArgItemprototypeUpdate args) {
        return itemService.itemprototypeUpdate(args);
    }

    @RequestMapping("/itemprototype/status")
    public Result itemprototypesSwitchStatus(@Validated @RequestBody ItemsServiceImpl.ArgItemprototypesSwitchStatus args) {
        return itemService.itemprototypesSwitchStatus(args);
    }


    @RequestMapping("/all")
    public Result allItems(@RequestBody ItemsServiceImpl.ArgAllItems args) {
        return itemService.allItems(args);
    }

    @RequestMapping("/itemprototype/all")
    public Result allItemprototype(@RequestBody ItemsServiceImpl.ArgAllItemprototype args) {
        return itemService.allItemprototype(args);
    }

    @RequestMapping("/tagList")
    public Result tagList(@RequestBody ItemsServiceImpl.ArgTagList args) {
        return itemService.tagList(args);
    }


    @RequestMapping("/history")
    public Result get(@RequestBody ItemsServiceImpl.ArgHistory args) {
        return itemService.history(args);
    }


}
