package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.model.ItemTag;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public interface ItemTagMapper extends BaseMapper<ItemTag>  {


    @Select("<script> " +
            "SELECT t.tag,COUNT(t.tag) num " +
            "from item_tag t,items i " +
            "WHERE i.itemid = t.itemid " +
            "and i.hostid in " +
            "<foreach collection='hostids' index='index' item='item' open='(' separator=',' close=')'>" +
            "#{item}" +
            "</foreach>" +
            "and i.flags IN (0,4) " +
            "GROUP BY t.tag" +
            "</script> ")
    List<Map> tagList(@Param("hostids") ArrayList<Long> hostids);

}
