package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.mapper.res.ResItemData;
import com.zh.test_zabbix.mapper.res.ResItemList;
import com.zh.test_zabbix.mapper.res.ResItemTriggerList;
import com.zh.test_zabbix.model.Items;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

public interface ItemsMapper extends BaseMapper<Items> {

    @Select("<script> " +
            "SELECT DISTINCT i.itemid,i.type,i.hostid,i.name,i.name_upper,i.key_,i.delay,i.history,i.trends,i.status,i.value_type,i.templateid,i.flags,i.master_itemid," +
            "ir.state,COALESCE(ir.error,'') AS error " +
            "FROM items i " +
            "LEFT JOIN item_rtdata ir ON i.itemid=ir.itemid " +
            "WHERE 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<ResItemList> itemList(@Param("ew") Wrapper<Items> qw);

    @Select("<script> " +
            "SELECT DISTINCT t.triggerid,f.itemid,t.description,t.expression,t.recovery_mode,t.recovery_expression,t.priority,t.status,t.state,t.error,t.templateid,t.flags " +
                    "FROM triggers t " +
                    "LEFT JOIN functions f on f.triggerid = t.triggerid "+
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<ResItemTriggerList> itemTriggerList(@Param("ew") Wrapper<Items> qw);

    @Select("<script> " +
            "SELECT i.itemid,i.type,i.hostid,i.name,i.key_,i.delay,i.history,i.trends,i.status,i.value_type,i.units,i.description,ir.state,COALESCE(ir.error, '') AS error,i.valuemapid " +
            "FROM items i " +
            "LEFT JOIN item_rtdata ir ON i.itemid = ir.itemid " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<ResItemData> itemData(@Param("ew") Wrapper<Items> qw);
}
