package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.mapper.res.ResCustomItems;
import com.zh.test_zabbix.model.MsCustomItems;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-11-09
 */
public interface MsCustomItemsMapper extends BaseMapper<MsCustomItems> {

    @Select("<script> " +
            "SELECT ci.id,ci.name,ci.kind,ci.history,i.key_,i.itemid,i.value_type,i.units " +
            "FROM ms_custom_items ci " +
            "left join items i on  i.key_ like CONCAT('%', ci.key_, '%') " +
            "WHERE 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<ResCustomItems> list(@Param("ew") Wrapper<MsCustomItems> qw);
}
