package com.zh.test_zabbix.mapper;

import com.alibaba.fastjson.JSONObject;
import com.zh.test_zabbix.model.MsHostCollection;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.ArrayList;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-11-07
 */
public interface MsHostCollectionMapper extends BaseMapper<MsHostCollection> {

    @Select("<script> " +
            "SELECT " +
//            "categoryid id,cate.name" +
            "IFNULL(categoryid,-1) id,IFNULL(cate.name,\'未分组\') name " +
            ",COUNT(1) sum FROM `hosts` h\n" +
            "LEFT JOIN ms_host_category cate\n" +
            " on cate.id = h.categoryid\n" +
            "WHERE h.flags in (0,4) and h.status in (0,1)\n" +
            "<if test='collectionid'> " +
            "and collectionid = #{collectionid}\n" +
            "</if>" +
            "GROUP BY categoryid ORDER BY id " +
            "</script> ")
    ArrayList<JSONObject> count(@Param("collectionid") int collectionid);

}
