package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.mapper.res.ResProblem;
import com.zh.test_zabbix.model.Problem;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-11-07
 */
public interface ProblemMapper extends BaseMapper<Problem> {
    @Select("<script> " +
            "SELECT severity, count(*) as num " +
            "FROM problem p,functions f,items i ,hosts h " +
            "WHERE p.objectid=f.triggerid AND f.itemid=i.itemid AND i.hostid = h.hostid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "GROUP BY p.severity" +
            "</script> ")
    List<Map> countBySeverity(@Param("ew") Wrapper<Problem> qw);


    @Select("<script> " +
            "SELECT count(DISTINCT p.eventid) " +
            "FROM problem p,functions f,items i,hosts h " +
            "WHERE p.objectid=f.triggerid AND f.itemid=i.itemid AND i.hostid = h.hostid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer count(@Param("ew") Wrapper<Problem> qw);

    @Select("<script> " +
            "SELECT DISTINCT p.eventid,p.objectid as triggerid,p.clock,p.ns,p.name,p.severity,p.cause_eventid,i.itemid,i.name as item_name,h.hostid,h.name as host_name,h.collectionid " +
            "FROM problem p,functions f,items i,hosts h " +
            "WHERE p.objectid=f.triggerid AND f.itemid=i.itemid AND i.hostid = h.hostid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<ResProblem> get(@Param("ew") Wrapper<Problem> qw);
}
