package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.model.Triggers;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-10-26
 */
public interface TriggersMapper extends BaseMapper<Triggers> {

    @Select("<script> " +
            "SELECT COUNT(DISTINCT t.triggerid) AS rowscount,i.hostid " +
            "FROM triggers t,functions f,items i " +
            "WHERE f.triggerid=t.triggerid AND f.itemid=i.itemid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "GROUP BY i.hostid" +
            "</script> ")
    List<Map> countHostTrigger(@Param("ew") Wrapper<Triggers> qw);

    @Select("<script> " +
            "SELECT count(DISTINCT t.triggerid)  " +
            "FROM triggers t,functions f,items i,hosts h " +
            "WHERE " +
            "f.triggerid=t.triggerid " +
            "AND f.itemid=i.itemid " +
            "AND h.hostid=i.hostid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer count(@Param("ew") Wrapper<Triggers> qw);

    @Select("<script> " +
            "SELECT DISTINCT t.triggerid,t.description  " +
            "FROM triggers t,functions f,items i,hosts h " +
            "WHERE " +
            "f.triggerid=t.triggerid " +
            "AND f.itemid=i.itemid " +
            "AND h.hostid=i.hostid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<Triggers> triggerids(@Param("ew") Wrapper<Triggers> qw);

    @Select("<script> " +
            "SELECT COUNT(DISTINCT t.triggerid) AS rowscount,id.parent_itemid " +
            "FROM triggers t,functions f,item_discovery id " +
            "WHERE f.triggerid=t.triggerid AND f.itemid=id.itemid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<Map> countItemDiscoveryTrigger(@Param("ew") Wrapper<Triggers> qw);

    @Select("<script> " +
            "SELECT count(DISTINCT t.triggerid)  " +
            "FROM triggers t,functions f,item_discovery id " +
            "WHERE " +
            "f.triggerid=t.triggerid " +
            "AND f.itemid=id.itemid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer countTriggerprototype(@Param("ew") Wrapper<Triggers> qw);

    @Select("<script> " +
            "SELECT DISTINCT t.triggerid,t.description  " +
            "FROM triggers t,functions f,item_discovery id " +
            "WHERE " +
            "f.triggerid=t.triggerid " +
            "AND f.itemid=id.itemid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<Triggers> triggerprototypeids(@Param("ew") Wrapper<Triggers> qw);

}
