package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.mapper.res.ResUsers;
import com.zh.test_zabbix.model.Users;
import com.zh.test_zabbix.model.Usrgrp;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-11-22
 */
public interface UsersMapper extends BaseMapper<Users> {

    @Select("<script> " +
            "SELECT userid,username,name,surname,autologout,attempt_failed,roleid,userdirectoryid,ts_provisioned " +
            "FROM users " +
            "WHERE 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<ResUsers> get(@Param("ew") Wrapper<Users> qw);

    @Select("<script> " +
            "SELECT t.usrgrpid,u.userid,u.username,u.name,u.surname " +
            "FROM users u,users_groups t " +
            "WHERE u.userid = t.userid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<Map> getByUsrGrp(@Param("ew") Wrapper<Usrgrp> qw);

    @Select("<script> " +
            "SELECT ug.userid," +
//            "MAX(g.gui_access) AS gui_access, MAX(g.debug_mode) AS debug_mode," +
            "MAX(g.users_status) AS users_status " +
            "FROM usrgrp g,users_groups ug " +
            "WHERE g.usrgrpid=ug.usrgrpid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "GROUP BY ug.userid " +
            "</script> ")
    List<Map> user_status(@Param("ew") Wrapper<Users> qw);

}
