package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.model.Users;
import com.zh.test_zabbix.model.Usrgrp;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-11-22
 */
public interface  UsrgrpMapper extends BaseMapper<Usrgrp> {

    @Select("<script> " +
            "SELECT t.userid,g.usrgrpid,g.name,g.gui_access,g.users_status " +
            "FROM users_groups t,usrgrp g " +
            "WHERE g.usrgrpid =t.usrgrpid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<Map> getByUsers(@Param("ew") Wrapper<Users> qw);

    @Select("<script> " +
            "SELECT hg.groupid,hg.name,hg.type,CASE WHEN MIN(r.permission)=0 THEN 0 ELSE MAX(r.permission) END AS permission " +
            "FROM hstgrp hg,rights r " +
            "WHERE hg.groupid =r.id " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "GROUP BY r.id" +
            "</script> ")
    List<Map> rights(@Param("ew") Wrapper<Usrgrp> qw);
}
