package com.zh.test_zabbix.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.experimental.Accessors;

@Data
@Accessors(chain = true)
@TableName("ms_host_items")
public class HostItems {

    @TableId(value = "id", type = IdType.AUTO)
    Integer id;
    String hostid;  // 主机id
    int itemid; // 监控项id
    String name;    // 监控项名称
    String key_;    // 监控项键值
    int kind;  // 1:CPU;2:memory;3:disk;4:fans;5:microcontroller;6:raid;7:network;8:temperature;9:power;
    @TableField(value = "value_type")
    int valueType; // 监控项的值的类型:0:浮点值;1:字符串;2:日志;3:无符号整数;4:文本。
    String param;  // 监控项key附带参数
    String target;   // 自动生成规则下发现多个并列监控目标
}
