package com.zh.test_zabbix.model.zabbixModel.host;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

@Data
public class ApiHosts {

    /* 	(只读) 主机的ID。 */
    @TableId(value = "hostid", type = IdType.AUTO)
    Integer hostid;

    int categoryid;
    int collectionid;



    /* 主机的正式名称。 */
    String host;

    /* 主机的描述信息。 */
    String description;

    /* (只读) 主机的来源。
    取值范围:
    0—普通主机;
    4—自动发现的主机。
    */
    int flags;

    /* 主机资产模式。
    取值范围为:
    -1 - (默认) 禁用的;
    0 - 手动的;
    1 - 自动的。
    */
//    int inventory_mode;

    /* IPMI 验证算法。
    可能的值:   -1 - (默认) default;  0 - none;   1 - MD2;    2 - MD5 4; - straight;   5 - OEM;    6 - RMCP+.
    */
    int ipmi_authtype = -1;

    /* 	IPMI 密码 */
    String ipmi_password;

    /* IPMI 权限等级。
    可能的值:
    1 - callback;   2 - (默认) user;  3 - operator;   4 - admin;  5 - OEM.
    */
    int ipmi_privilege = 2;

    /* IPMI 用户名。 */
    String ipmi_username;

    /* (只读) 有效维护启动时间。 */
    String maintenance_from;

    /* (只读) 有效的维护状态。
    取值包括:
    0 - (默认)不维护;
    1 -有效维护。
    */
    int maintenance_status = 0;

    /* 	(只读) 有效的维护类型。
    可能的值是:
    0 - (默认) 数据收集维护;
    1 - 数据不收集维护。
    */
    int maintenance_type = 0;

    /* 	(只读) 主机上当前生效的维护ID。 */
    String maintenanceid;

    /* 可见的主机名。默认: host 属性值。 */
    String name = "host";

    /* 用于监控主机的Proxy ID。*/
    String proxy_hostid;

    /* 主机的状态和功能。
    可能的值是:
    0 - (默认) 开启监控的主机;
    1 - 没有开启监控的主机。
    */
    int status = 0;

    /* 链接到主机。
    可能的值是:
    1 - (默认) 没有加密;  2 - PSK;    4 - 已加密。
    */
    int tls_connect = 1;

    /* 连接主机。
    可能的位图值如下::
    1 - (默认) 未加密;   2 - PSK;    4 - 已认证.
    */
    int tls_accept = 1;

    /* 	证书问题。 */
    String tls_issuer;

    /* 	证书发行者。 */
    String tls_subject;

    /* (只写) PSK 认证。 如果启用了 tls_connect 或 tls_accept ，则需要。
    不要将敏感信息放入PSK标识中，该信息通过网络明文传输，以告知接收端使用哪个PSK。
    */
    String tls_psk_identity;

    /* (只写) 预共享密钥，至少32位十六进制数字。如果启用了 tls_connect 或 tls_accept ，则需要。 */
    String tls_psk;
}


