package com.zh.test_zabbix.script;

import com.jcraft.jsch.*;
import com.zh.test_zabbix.config.Config;

public class LinuxUtil {
    public static Boolean scp(String hostname, String username, String password) {
        try {
            JSch jsch = new JSch();

            // 创建会话
            Session session = jsch.getSession(username, hostname, 22);
            session.setPassword(password);

            // 配置会话选项
            session.setConfig("StrictHostKeyChecking", "no");

            // 连接远程服务器
            session.connect();

            // 打开SFTP通道
            ChannelSftp channelSftp = (ChannelSftp) session.openChannel("sftp");
            channelSftp.connect();

            // 上传文件
            channelSftp.put(Config.ZABBIX_AGENT_FILE, Config.ZABBIX_AGENT_FILE_LOCATION);

            // 关闭SFTP通道和会话
            channelSftp.disconnect();
            session.disconnect();
        } catch (JSchException | SftpException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
}